# Edit a webhook

PATCH https://api.letsdeel.com/rest/v2/webhooks/{id}
Content-Type: application/json

Edit a webhook subscription.

Reference: https://developer.deel.com/api/endpoints/webhooks/update-webhook

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Deel HRIS SCIM API
  version: 1.0.0
paths:
  /webhooks/{id}:
    patch:
      operationId: update-webhook
      summary: Edit a webhook
      description: Edit a webhook subscription.
      tags:
        - subpackage_webhooks
      parameters:
        - name: id
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >
            ## Authentication

            The Deel API uses bearer tokens to authenticate requests. All API
            calls must be made over HTTPS — calls over plain HTTP or without
            authentication will fail.


            ```curl

            curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
              -H 'Authorization: Bearer YOUR-TOKEN-HERE'
            ```


            [Learn more about authentication](/api/authentication)
          required: true
          schema:
            type: string
      responses:
        '200':
          description: successful operation
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/WebhookItemResponse'
        '400':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '401':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '403':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '404':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '405':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '429':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
        '500':
          description: Operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ApiErrorContainer'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/PatchWebhookRequest'
servers:
  - url: https://api.letsdeel.com/rest/v2
  - url: https://api-staging.letsdeel.com/rest/v2
components:
  schemas:
    PatchWebhookRequestStatus:
      type: string
      enum:
        - enabled
        - disabled
      description: Status of webhook.
      title: PatchWebhookRequestStatus
    PatchWebhookRequest:
      type: object
      properties:
        name:
          type:
            - string
            - 'null'
          description: Webhook subscription name.
        description:
          type:
            - string
            - 'null'
          description: Webhook subscription description.
        status:
          $ref: '#/components/schemas/PatchWebhookRequestStatus'
          description: Status of webhook.
        url:
          type: string
          description: Endpoint to receive webhook.
        signing_key:
          type:
            - string
            - 'null'
          description: The webhook's signing key, used to generate webhook signatures.
        api_version:
          type: string
          default: v2
          description: Deel API version. Currently Deel accepts v1 or v2 version.
        events:
          type: array
          items:
            type: string
          description: The list of events to enable for this subscription.
      required:
        - name
        - description
        - status
        - url
        - signing_key
        - events
      title: PatchWebhookRequest
    WebhookItemStatus:
      type: string
      enum:
        - enabled
        - disabled
      description: Status of webhook.
      title: WebhookItemStatus
    WebhookItem:
      type: object
      properties:
        id:
          type: string
          description: Unique identifier of this resource.
        name:
          type:
            - string
            - 'null'
          description: Webhook subscription name.
        description:
          type:
            - string
            - 'null'
          description: Webhook subscription description.
        status:
          $ref: '#/components/schemas/WebhookItemStatus'
          description: Status of webhook.
        url:
          type: string
          description: Endpoint to receive webhook.
        signing_key:
          type:
            - string
            - 'null'
          description: The webhook's signing key, used to generate webhook signatures.
        api_version:
          type: string
          default: v2
          description: Deel API version. Currently Deel accepts v1 or v2 version.
        events:
          type: array
          items:
            type: string
          description: The list of events to enable for this subscription.
        created_at:
          type: string
          description: Time at which the webhook was created.
        updated_at:
          type: string
          description: Time at which the webhook was updated.
        hidden:
          type:
            - boolean
            - 'null'
          description: >-
            Property to hide the webhook from frontend view. Commonly by Dell
            3rd party apps
        internal:
          type: boolean
        deleted_at:
          type: string
          description: Time at which the webhook was deleted.
      required:
        - id
        - name
        - description
        - status
        - url
        - signing_key
        - api_version
        - events
        - created_at
        - updated_at
      title: WebhookItem
    WebhookItemResponse:
      type: object
      properties:
        data:
          $ref: '#/components/schemas/WebhookItem'
      required:
        - data
      title: WebhookItemResponse
    ApiErrorRequest:
      type: object
      properties:
        method:
          type: string
          description: The HTTP method of the failed request
        url:
          type: string
          description: The relative URL of the failed request
        status:
          type: number
          format: double
          description: The status code of the response
        api_req_id:
          type: string
          description: The request ID of the failed request
        docs:
          type: string
          description: >-
            A link to the official documentation for the requested endpoint
            resource
        source:
          type: string
          description: The source handler which produced the returned error
        code:
          type: number
          format: double
          description: The code of the source handler which produced the returned error
      title: ApiErrorRequest
    ApiError:
      type: object
      properties:
        message:
          type: string
          description: A description of the returned error
        path:
          type: string
          description: The JSON path where input validation failed
      title: ApiError
    ApiErrorContainer:
      type: object
      properties:
        request:
          $ref: '#/components/schemas/ApiErrorRequest'
        errors:
          type: array
          items:
            $ref: '#/components/schemas/ApiError'
      title: ApiErrorContainer
  securitySchemes:
    deelToken:
      type: http
      scheme: bearer
      description: >
        ## Authentication

        The Deel API uses bearer tokens to authenticate requests. All API calls
        must be made over HTTPS — calls over plain HTTP or without
        authentication will fail.


        ```curl

        curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \
          -H 'Authorization: Bearer YOUR-TOKEN-HERE'
        ```


        [Learn more about authentication](/api/authentication)
    oauth2:
      type: http
      scheme: bearer
      description: >-
        Standard OAuth2 security scheme based on
        https://swagger.io/docs/specification/authentication/

```

## SDK Code Examples

```python
import requests

url = "https://api.letsdeel.com/rest/v2/webhooks/id"

payload = { "body": {
        "name": "Invoice Payment Webhook",
        "description": "Webhook to notify when an invoice is paid",
        "status": "enabled",
        "url": "https://hooks.example.com/invoice-payment",
        "signing_key": "a1b2c3d4e5f67890abcdef1234567890",
        "events": ["invoice.paid"]
    } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.letsdeel.com/rest/v2/webhooks/id';
const options = {
  method: 'PATCH',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"body":{"name":"Invoice Payment Webhook","description":"Webhook to notify when an invoice is paid","status":"enabled","url":"https://hooks.example.com/invoice-payment","signing_key":"a1b2c3d4e5f67890abcdef1234567890","events":["invoice.paid"]}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/v2/webhooks/id"

	payload := strings.NewReader("{\n  \"body\": {\n    \"name\": \"Invoice Payment Webhook\",\n    \"description\": \"Webhook to notify when an invoice is paid\",\n    \"status\": \"enabled\",\n    \"url\": \"https://hooks.example.com/invoice-payment\",\n    \"signing_key\": \"a1b2c3d4e5f67890abcdef1234567890\",\n    \"events\": [\n      \"invoice.paid\"\n    ]\n  }\n}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/v2/webhooks/id")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"body\": {\n    \"name\": \"Invoice Payment Webhook\",\n    \"description\": \"Webhook to notify when an invoice is paid\",\n    \"status\": \"enabled\",\n    \"url\": \"https://hooks.example.com/invoice-payment\",\n    \"signing_key\": \"a1b2c3d4e5f67890abcdef1234567890\",\n    \"events\": [\n      \"invoice.paid\"\n    ]\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://api.letsdeel.com/rest/v2/webhooks/id")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"body\": {\n    \"name\": \"Invoice Payment Webhook\",\n    \"description\": \"Webhook to notify when an invoice is paid\",\n    \"status\": \"enabled\",\n    \"url\": \"https://hooks.example.com/invoice-payment\",\n    \"signing_key\": \"a1b2c3d4e5f67890abcdef1234567890\",\n    \"events\": [\n      \"invoice.paid\"\n    ]\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://api.letsdeel.com/rest/v2/webhooks/id', [
  'body' => '{
  "body": {
    "name": "Invoice Payment Webhook",
    "description": "Webhook to notify when an invoice is paid",
    "status": "enabled",
    "url": "https://hooks.example.com/invoice-payment",
    "signing_key": "a1b2c3d4e5f67890abcdef1234567890",
    "events": [
      "invoice.paid"
    ]
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/v2/webhooks/id");
var request = new RestRequest(Method.PATCH);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"body\": {\n    \"name\": \"Invoice Payment Webhook\",\n    \"description\": \"Webhook to notify when an invoice is paid\",\n    \"status\": \"enabled\",\n    \"url\": \"https://hooks.example.com/invoice-payment\",\n    \"signing_key\": \"a1b2c3d4e5f67890abcdef1234567890\",\n    \"events\": [\n      \"invoice.paid\"\n    ]\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["body": [
    "name": "Invoice Payment Webhook",
    "description": "Webhook to notify when an invoice is paid",
    "status": "enabled",
    "url": "https://hooks.example.com/invoice-payment",
    "signing_key": "a1b2c3d4e5f67890abcdef1234567890",
    "events": ["invoice.paid"]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/v2/webhooks/id")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```